from sklearn.datasets import load_iris
from sklearn.model_selection import train_test_split
from sklearn.neural_network import MLPClassifier

# Irisデータを取得
iris = load_iris()
x, y = iris.data, iris.target
# 訓練データとテストデータに分割
x_train, x_test, y_train, y_test = \
    train_test_split(x, y, test_size=0.5, random_state=0)
# 初期化
nn = MLPClassifier(solver="sgd", random_state=0, max_iter=10000)
# 学習
nn.fit(x_train, y_train)
# 予測した結果の表示
print ("result", nn.score(x_test, y_test))
