import numpy as np

# 状態は以下の4つとする
S = np.array([0, 1, 2, 3])
# 行動は前後をそれぞれ0と1とする
A = np.array([0, 1])
# 各状態から移動したときの報酬を与える
R = np.array([[1, -20], [4, -1], [0, 25], [0, 0]])
# 行動による移動先を与える
S1 = np.array([[1, 2], [3, 0], [0, 3], [None, None]])

# 前に動く確率
p = 0.5
# 学習率
alpha = 0.01
# 割引率
gamma = 0.8
# 試行回数
n = 3000

# テーブルを初期化
Q = np.zeros(R.shape)

# 移動方向を確率的に決める
def pi(p):
    if np.random.uniform(0, 1) <= p:
        return 0 # 前
    else:
        return 1 # 後

def sarsa():
    s = S[0]
    a = pi(p)
    while S1[s, a] != None:
        a_next = pi(p)
        td = R[s, a] + gamma * Q[S1[s, a], a_next] - Q[s, a]
        Q[s, a] += alpha * td
        s = S1[s, a]
        a = a_next
    print(Q[0, 0], Q[0, 1])

for i in range(n):
    sarsa()